#include<bits/stdc++.h>
#define ll long long
using namespace std;


int main()
{
   ll n,q;
   cin>>n>>q;
   vector<ll> a;
   vector<int> countr;
   for(ll i=0;i<n;i++)
   {
       int x;
       cin>>x;
       a.push_back(x);

   }
   for(ll i=0;i<q;i++)
   {
       ll l,r;
       cin>>l>>r;
       int maks=1;
       for(int i=l;i<r;i++)
       {
           
           tr=a[i];
           int cntr=1;
           for(int j=l;j<r;j++)
           {
               if(tr==a[j]) cntr++;
           }
           if(cntr>maks)
           {
               maks=cntr;
           }
       }
       countr.push_back(maks);
   }
   for(int i=0;i<q;i++)
   {

      cout<<countr[countr.size()-i-1]<<endl;
   }

}